

-- Helpful Info:
-- http://craftydba.com/?page_id=880  -- Sep 2011 (SNESSUG) / Mar 2013 (SAT 184) / Apr 2013 (SAT 203) /Aug 2013 (SAT 235)


use msdb
go



if object_id('[dbo].[trig_sysjobs_insert_update_delete]') is not null
	drop trigger [dbo].[trig_sysjobs_insert_update_delete]
go

CREATE TRIGGER [dbo].[trig_sysjobs_insert_update_delete]
ON [dbo].[sysjobs]
FOR INSERT, UPDATE, DELETE
AS

--************************************************************************
--
-- Vers Who       Date       What
-- ---- --------- ---------- -------------------------
-- 1.0  ggable    09/21/2017 Initial Release
-- 1.1  ggable    09/28/2017 added condition not to insert when change comes from system automated update ('SQLAgent - Job Manager')
--************************************************************************



BEGIN

declare @lv_schemaName varchar(25) = 'dbo'
, @lv_tablename varchar(50) = 'sysjobs'



declare @lv_userName nvarchar(50) = user_name()
, @lv_sUserSName nvarchar(50) = suser_sname()
, @lv_originalLogin nvarchar(50) = original_login()
, @lv_applicationName nvarchar(50) = app_name()
, @lv_hostName nvarchar(50) = host_name()
, @lb_IncludeSystemAutomedUpdates bit = 0

select @lv_userName = user_name()
select @lv_sUserSName = suser_sname()
select @lv_originalLogin = original_login()
select @lv_applicationName = app_name()
select @lv_hostName = host_name()



IF @lv_applicationName <> 'SQLAgent - Job Manager' OR @lb_IncludeSystemAutomedUpdates = 1 BEGIN

	-- Detect inserts
	IF EXISTS (select * from inserted) AND NOT EXISTS (select * from deleted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'INSERT'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from inserted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM inserted as Record for xml auto, elements , root('RecordSet'), type)

	END


	-- Detect deletes
	IF EXISTS (select * from deleted) AND NOT EXISTS (select * from inserted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'DELETE'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from deleted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM deleted as Record for xml auto, elements , root('RecordSet'), type)

	END


	-- Detect updates
	IF EXISTS (select * from inserted) AND EXISTS (select * from deleted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'UPDATE'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from inserted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM deleted as Record for xml auto, elements , root('RecordSet'), type)

	END

END






END
GO




if object_id('[dbo].[trig_sysjobsteps_insert_update_delete]') is not null
	drop trigger [dbo].[trig_sysjobsteps_insert_update_delete]
go

CREATE TRIGGER [dbo].[trig_sysjobsteps_insert_update_delete]
ON [dbo].[sysjobsteps]
FOR INSERT, UPDATE, DELETE
AS

--************************************************************************
--
-- Vers Who       Date       What
-- ---- --------- ---------- -------------------------
-- 1.0  ggable    09/21/2017 Initial Release
-- 1.1  ggable    09/28/2017 added condition not to insert when change comes from system automated update ('SQLAgent - Job Manager')
--************************************************************************

BEGIN

declare @lv_schemaName varchar(25) = 'dbo'
, @lv_tablename varchar(50) = 'sysjobsteps'



declare @lv_userName nvarchar(50) = user_name()
, @lv_sUserSName nvarchar(50) = suser_sname()
, @lv_originalLogin nvarchar(50) = original_login()
, @lv_applicationName nvarchar(50) = app_name()
, @lv_hostName nvarchar(50) = host_name()
, @lb_IncludeSystemAutomedUpdates bit = 0

select @lv_userName = user_name()
select @lv_sUserSName = suser_sname()
select @lv_originalLogin = original_login()
select @lv_applicationName = app_name()
select @lv_hostName = host_name()


IF @lv_applicationName <> 'SQLAgent - Job Manager' OR @lb_IncludeSystemAutomedUpdates = 1 BEGIN

	-- Detect inserts
	IF EXISTS (select * from inserted) AND NOT EXISTS (select * from deleted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'INSERT'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from inserted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM inserted as Record for xml auto, elements , root('RecordSet'), type)

	END


	-- Detect deletes
	IF EXISTS (select * from deleted) AND NOT EXISTS (select * from inserted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'DELETE'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from deleted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM deleted as Record for xml auto, elements , root('RecordSet'), type)

	END


	-- Detect updates
	IF EXISTS (select * from inserted) AND EXISTS (select * from deleted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'UPDATE'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from inserted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM deleted as Record for xml auto, elements , root('RecordSet'), type)

	END


END




END
GO





if object_id('[dbo].[trig_sysjobschedules_insert_update_delete]') is not null
	drop trigger [dbo].[trig_sysjobschedules_insert_update_delete]
go

CREATE TRIGGER [dbo].[trig_sysjobschedules_insert_update_delete]
ON [dbo].[sysjobschedules]
FOR INSERT, UPDATE, DELETE
AS

--************************************************************************
--
-- Vers Who       Date       What
-- ---- --------- ---------- -------------------------
-- 1.0  ggable    09/21/2017 Initial Release
-- 1.1  ggable    09/28/2017 added condition not to insert when change comes from system automated update ('SQLAgent - Job Manager')
--************************************************************************

BEGIN

declare @lv_schemaName varchar(25) = 'dbo'
, @lv_tablename varchar(50) = 'sysjobschedules'



declare @lv_userName nvarchar(50) = user_name()
, @lv_sUserSName nvarchar(50) = suser_sname()
, @lv_originalLogin nvarchar(50) = original_login()
, @lv_applicationName nvarchar(50) = app_name()
, @lv_hostName nvarchar(50) = host_name()
, @lb_IncludeSystemAutomedUpdates bit = 0

select @lv_userName = user_name()
select @lv_sUserSName = suser_sname()
select @lv_originalLogin = original_login()
select @lv_applicationName = app_name()
select @lv_hostName = host_name()



IF @lv_applicationName <> 'SQLAgent - Job Manager' OR @lb_IncludeSystemAutomedUpdates = 1 BEGIN

	-- Detect inserts
	IF EXISTS (select * from inserted) AND NOT EXISTS (select * from deleted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'INSERT'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from inserted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM inserted as Record for xml auto, elements , root('RecordSet'), type)

	END


	-- Detect deletes
	IF EXISTS (select * from deleted) AND NOT EXISTS (select * from inserted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'DELETE'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from deleted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM deleted as Record for xml auto, elements , root('RecordSet'), type)

	END


	-- Detect updates
	IF EXISTS (select * from inserted) AND EXISTS (select * from deleted)
	BEGIN

		insert into dbo.AuditJobChanges (AuditChangeDate
										, AuditChangeType
										, AuditChangePerformedBy
										, ApplicationName
										, HostName
										, SchemaName
										, ObjectName
										, XML_RECSET
										)
			select getdate()
			, 'UPDATE'
			, @lv_sUserSName
			, @lv_applicationName
			, @lv_hostName
			, @lv_schemaName
			, @lv_tablename
			, XML_RECSET = (select * from inserted for xml path('RecordSet'), TYPE)
			--, (SELECT * FROM deleted as Record for xml auto, elements , root('RecordSet'), type)

	END


END






END
GO
